#include "Communication.h"
#include <iostream>

#ifdef WIN32
#   include <winsock.h>
#else
#   include <netinet/in.h>
#   include <arpa/inet.h>
#endif

#define VALID_PORT(port) ((port) > 0 && (port) < 65536)

using namespace std;

Communication::Communication(char * _server, int _port) {

	server.sin_addr.s_addr = (_server != NULL && inet_addr(_server) != INADDR_NONE)? inet_addr(_server) : inet_addr("127.0.0.1");
	server.sin_port = (VALID_PORT(_port))? htons(_port) : htons(3100);
	server.sin_family = AF_INET;
    
    pthread_mutex_init(&mutexsock, NULL);
    connect();
}

Communication::~Communication() {

    close();
    pthread_mutex_destroy(&mutexsock);
}

int Communication::connect() {
    
    pthread_mutex_lock(&mutexsock);
    socket.connect(&server);
    pthread_mutex_unlock(&mutexsock);
    
    return 0;
}

int Communication::close() {
    
    pthread_mutex_lock(&mutexsock);
    socket.close();
    pthread_mutex_unlock(&mutexsock);
    
    return 0;
}

/*!
 * Wrapper for Thread::start method
 */
int Communication::start() {

	cout << "Starting communication..." 
         << endl;

	int rc = Thread::start();
	
	if (rc) {
	
		cerr << "Failed to start communication" 
             << endl;
		
	} else {
	
		cout << "Communication started" 
             << endl;
	}
	
	return rc;
}

/*!
 * Wrapper for Thread::stop method
 */
int Communication::stop() {

	cout << "Stopping communication..." 
         << endl;

	int rc = Thread::stop();

	if (rc) {
	
		cerr << "Failed to stop communication" 
             << endl;
		
	} else {
	
		cout << "Communication stopped" 
             << endl;
	}
	
	return rc;
}

int Communication::send(char * msg) {

    pthread_mutex_lock(&mutexsock);
    socket.send(msg);
    pthread_mutex_unlock(&mutexsock);
    
    return 0;
}

int Communication::receive(char * msg) {
    
    pthread_mutex_lock(&mutexsock);
    socket.receive(msg);
    pthread_mutex_unlock(&mutexsock);
    
    return 0;
}

int Communication::run() {

    char msg[8192];

    while (signal != THREADSIG_STOP){

		receive(msg);
        send("(rae1_2 -3.14 0.0)(lae1_2 3.14 0.0)");
        
		if (strlen(msg) > 0) {
		
			cout << msg
                 << endl
                 << endl;
		}
    }
    
	return 0;
}
